IMPLEMENTATION MODULE FNames;

IMPORT Str, FIO;
IMPORT Lib2, Lib3, Config;

VAR
  der: FIO.DirEntry;


(* strip extension (including dot) *)
PROCEDURE MkBaseName( VAR d: ARRAY OF CHAR; s-: ARRAY OF CHAR );

  PROCEDURE Err();
  BEGIN
    Lib3.FatalError( 'FNames.MkBaseName: Destination too short' );
    HALT;
  END Err;

VAR
  l, i, j: CARDINAL;
BEGIN
  Str.Copy( d, s );
  l := Str.Length( s );
  i := Str.RCharPos( s, '.' );
  IF i >= l THEN
    IF l > SIZE( d ) THEN Err() END;
    RETURN;
  END;
  j := Str.RCharPos( s, '\' );
  IF ( j >= l ) OR ( i > j ) THEN
    IF i >= SIZE( d ) THEN Err() END;
    d[ i ] := 0C;
    RETURN;
  END;
  IF l > SIZE( d ) THEN Err() END;
END MkBaseName;

(* strip everything behind rightmost backslash *)
PROCEDURE MkDirName( VAR d: ARRAY OF CHAR; s-: ARRAY OF CHAR );

  PROCEDURE Err();
  BEGIN
    Lib3.FatalError( 'FNames.MkDirName: Destination too short' );
    HALT;
  END Err;

VAR
  l, i: CARDINAL;
BEGIN
  l := Str.Length( s );
  i := Str.RCharPos( s, '\' );
  IF i >= l THEN  (* no backslash *)
    d[ 0 ] := 0C;
    RETURN;
  END;
  Str.Copy( d, s );
  INC( i );
  IF i > SIZE( d ) THEN Err() END;
  IF i < SIZE( d ) THEN d[ i ] := 0C END;
END MkDirName;

PROCEDURE MkNames();
BEGIN
  MkDirName( in, Config.data.in );
  Str.Append( in, der.name );

  IF Config.data.out # '' THEN
    Str.Copy( out, Config.data.out );
  ELSE
    MkBaseName( out, in );
    Str.Append( out, '.txt' );
  END;
END MkNames;


PROCEDURE First(): BOOLEAN;
CONST
  fa = FIO.FileAttr{ (* FIO.readonly, FIO.archive *) };
VAR
  ioc,
  ok: BOOLEAN;
BEGIN
  ioc := FIO.IOcheck;
  FIO.IOcheck := FALSE;
  ok := FIO.ReadFirstEntry( Config.data.in, fa, der );
  FIO.IOcheck := ioc;
  IF ok THEN MkNames() END;
  RETURN ok;
END First;

PROCEDURE Next(): BOOLEAN;
VAR
  ok: BOOLEAN;
BEGIN
  ok := FIO.ReadNextEntry( der );
  IF ok THEN MkNames() END;
  RETURN ok;
END Next;

PROCEDURE Close();
BEGIN
  FIO.ReadClose( der );
  Lib2.Fill( der, 0 );
END Close;

PROCEDURE InitModule();
BEGIN
  in  := '';
  out := '';
  Lib2.Fill( der, 0 );
END InitModule;

BEGIN
  InitModule();
END FNames.
